import { ConnectionBase } from "@lindorm-io/core-connection";
import { ILogger } from "@lindorm-io/winston";
import { IPostgresConnection, PostgresConnectionOptions } from "../types";
import { Pool, PoolConfig, QueryConfig, QueryResult, QueryResultRow } from "pg";
export declare class PostgresConnection extends ConnectionBase<Pool, PoolConfig> implements IPostgresConnection {
    private readonly custom;
    constructor(options: PostgresConnectionOptions, logger: ILogger);
    protected createClientConnection(): Promise<Pool>;
    protected connectCallback(): Promise<void>;
    protected disconnectCallback(): Promise<void>;
    query<TResult extends QueryResultRow = QueryResultRow, TValues extends Array<any> = Array<any>>(queryTextOrConfig: QueryConfig<TValues> | string, values?: TValues): Promise<QueryResult<TResult>>;
}
